Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/moleculelist.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -310,352 +148,102 @@
   atom *Walker = NULL;
   vector BoxDimension;
-  char TEFilename[MAXSTRINGSIZE];
   char *FragmentNumber;
   int FragmentCounter = 0;
   ofstream output;
-  element *runner = NULL;
   
   // store the fragments as config and as xyz
   for(int i=0;i<NumberOfMolecules;i++) {
-    //if (TEList[i] != 0) {
-      strcpy(PathBackup, configuration->configpath);
-
-      // scan all atoms in the current molecule for their fathers and write each vertex index to forces file
-
-      // correct periodic
-      ListOfMolecules[i]->ScanForPeriodicCorrection((ofstream *)&cout);
-
-      // output xyz file
-      FragmentNumber = FixedDigitNumber(NumberOfMolecules, FragmentCounter++);
-      sprintf(FragmentName, "%s/%s%s.conf.xyz", PathBackup, prefix, FragmentNumber);
-      outputFragment.open(FragmentName, ios::out);
-      cout << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << " as XYZ ...";
-      if (intermediateResult = ListOfMolecules[i]->OutputXYZ(&outputFragment))
-        cout << " done." << endl;
-      else
-        cout << " failed." << endl;
-      result = result && intermediateResult;
-      outputFragment.close();
-      outputFragment.clear();
-  
-      cout << Verbose(2) << "Contained atoms: ";
-      Walker = ListOfMolecules[i]->start;
-      while (Walker->next != ListOfMolecules[i]->end) {
-        Walker = Walker->next;
-        cout << Walker->Name << " ";
-      }
-      cout << endl;
-      // prepare output of config file
-      sprintf(FragmentName, "%s/%s%s.conf", PathBackup, prefix, FragmentNumber);
-      outputFragment.open(FragmentName, ios::out);
-      strcpy(PathBackup, configuration->configpath);
-      sprintf(FragmentName, "%s/%s%s/", PathBackup, prefix, FragmentNumber);
-      
-      // center on edge
-      ListOfMolecules[i]->CenterEdge((ofstream *)&cout, &BoxDimension);
-      ListOfMolecules[i]->SetBoxDimension(&BoxDimension);  // update Box of atoms by boundary
-      int j = -1;
-      for (int k=0;k<3;k++) {
-        j += k+1;
-        BoxDimension.x[k] = 5.;
-        ListOfMolecules[i]->cell_size[j] += BoxDimension.x[k]*2.;
-      }
-      ListOfMolecules[i]->Translate(&BoxDimension);
-
-      // also calculate necessary orbitals
-      ListOfMolecules[i]->CountElements();  // this is a bugfix, atoms should should actually be added correctly to this fragment 
-      ListOfMolecules[i]->CalculateOrbitals(*configuration);
-      
-      // change path in config
-      configuration->SetDefaultPath(FragmentName);
-      cout << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << " as config ...";
-      if (intermediateResult = configuration->Save(&outputFragment, ListOfMolecules[i]->elemente, ListOfMolecules[i]))
-        cout << " done." << endl;
-      else
-        cout << " failed." << endl;
-      // restore old config
-      configuration->SetDefaultPath(PathBackup);
-      
-      result = result && intermediateResult;
-      outputFragment.close();
-      outputFragment.clear();
-      Free((void **)&FragmentNumber, "MoleculeListClass::OutputConfigForListOfFragments: *FragmentNumber");
-    }
-
-  strcpy(PathBackup, configuration->configpath);
-  // open file for the total energy factor
-  sprintf(TEFilename, "%s/%s%s", PathBackup, prefix, TEFACTORSFILE);
-  output.open(TEFilename, ios::out);
-  // output TEList (later to file AtomicTEList.dat)
-  cout << Verbose(2) << "Saving " << prefix << " energy factors ...";
-  //cout << Verbose(1) << "Final ATEList: ";
-  //less output << prefix << "TE\t";
-  for(int i=0;i<NumberOfMolecules;i++) {
-    //cout << TEList[i] << "\t";
-    //if (TEList[i] != 0)
-      output << TEList[i] << "\t";
-  }
-  //cout << endl;
-  output << endl;
+    // save default path as it is changed for each fragment
+    strcpy(PathBackup, configuration->GetDefaultPath());
+
+    // correct periodic
+    ListOfMolecules[i]->ScanForPeriodicCorrection(out);
+
+    // output xyz file
+    FragmentNumber = FixedDigitNumber(NumberOfMolecules, FragmentCounter++);
+    sprintf(FragmentName, "%s/%s%s.conf.xyz", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    outputFragment.open(FragmentName, ios::out);
+    *out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << " as XYZ ...";
+    if (intermediateResult = ListOfMolecules[i]->OutputXYZ(&outputFragment))
+      *out << " done." << endl;
+    else
+      *out << " failed." << endl;
+    result = result && intermediateResult;
+    outputFragment.close();
+    outputFragment.clear();
+
+    *out << Verbose(2) << "Contained atoms: ";
+    Walker = ListOfMolecules[i]->start;
+    while (Walker->next != ListOfMolecules[i]->end) {
+      Walker = Walker->next;
+      *out << Walker->Name << " ";
+    }
+    *out << endl;
+    // prepare output of config file
+    sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    outputFragment.open(FragmentName, ios::out);
+    strcpy(PathBackup, configuration->configpath);
+    sprintf(FragmentName, "%s/%s%s/", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
+    
+    // center on edge
+    ListOfMolecules[i]->CenterEdge(out, &BoxDimension);
+    ListOfMolecules[i]->SetBoxDimension(&BoxDimension);  // update Box of atoms by boundary
+    int j = -1;
+    for (int k=0;k<3;k++) {
+      j += k+1;
+      BoxDimension.x[k] = 5.;
+      ListOfMolecules[i]->cell_size[j] += BoxDimension.x[k]*2.;
+    }
+    ListOfMolecules[i]->Translate(&BoxDimension);
+
+    // also calculate necessary orbitals
+    ListOfMolecules[i]->CountElements();  // this is a bugfix, atoms should should actually be added correctly to this fragment 
+    ListOfMolecules[i]->CalculateOrbitals(*configuration);
+    
+    // change path in config
+    configuration->SetDefaultPath(FragmentName);
+    *out << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << " as config ...";
+    if (intermediateResult = configuration->Save(&outputFragment, ListOfMolecules[i]->elemente, ListOfMolecules[i]))
+      *out << " done." << endl;
+    else
+      *out << " failed." << endl;
+    // restore old config
+    configuration->SetDefaultPath(PathBackup);
+    
+    result = result && intermediateResult;
+    outputFragment.close();
+    outputFragment.clear();
+    Free((void **)&FragmentNumber, "MoleculeListClass::OutputConfigForListOfFragments: *FragmentNumber");
+  }
+
+  // open KeySet file
+  sprintf(FragmentName, "%s/%s%s", configuration->configpath,  FRAGMENTPREFIX , KEYSETFILE);
+  output.open(FragmentName, ios::out);
+  *out << Verbose(2) << "Saving " << FRAGMENTPREFIX << " key sets of each subgraph ...";
+  for(int j=0;j<NumberOfMolecules;j++) {
+    Walker = ListOfMolecules[j]->start;
+    while(Walker->next != ListOfMolecules[j]->end) {
+      Walker = Walker->next;        
+#ifdef ADDHYDROGEN
+      if ((Walker->GetTrueFather() != NULL) && (Walker->type->Z != 1)) // if there is a real father, prints its index
+#else
+      if ((Walker->GetTrueFather() != NULL)) // if there is a real father, prints its index
+#endif 
+        output <<  Walker->GetTrueFather()->nr << "\t";
+#ifdef ADDHYDROGEN
+      else  // otherwise a -1 to indicate an added saturation hydrogen
+        output << "-1\t";
+#endif 
+    }
+    output << endl;
+  }
   output.close();
-  cout << " done." << endl;
-  
-  // open file for the force factors
-  sprintf(TEFilename, "%s/%s%s", PathBackup, prefix, FORCESFILE);
-  output.open(TEFilename, ios::out);
-  //cout << Verbose(1) << "Final AtomicForcesList: ";
-  cout << Verbose(2) << "Saving " << prefix << " force factors ...";
-  //output << prefix << "Forces" << endl;
-  for(int j=0;j<NumberOfMolecules;j++) {
-    //if (TEList[j] != 0) {
-    runner = ListOfMolecules[j]->elemente->start;
-    while (runner->next != ListOfMolecules[j]->elemente->end) { // go through every element
-      runner = runner->next;
-      if (ListOfMolecules[j]->ElementsInMolecule[runner->Z]) { // if this element got atoms
-        Walker = ListOfMolecules[j]->start;
-        while (Walker->next != ListOfMolecules[j]->end) { // go through every atom of this element
-          Walker = Walker->next;
-          if (Walker->type->Z == runner->Z) {
-            if ((Walker->GetTrueFather() != NULL) && (Walker->GetTrueFather() != Walker)) {// if there is a real father, prints its index
-              //cout << "Walker is " << *Walker << " with true father " << *( Walker->GetTrueFather()) << ", its number " << Walker->GetTrueFather()->nr << " and index " << SortIndex[Walker->GetTrueFather()->nr] << "." << endl;  
-              output <<  SortIndex[Walker->GetTrueFather()->nr] << "\t";
-            } else  // otherwise a -1 to indicate an added saturation hydrogen
-              output << "-1\t";
-          }
-        }
-      }
-    }
-    //cout << endl << endl;
-    output << endl;
-  }
-  output.close();
-  cout << " done." << endl;
-
-  // open KeySet file
-  sprintf(TEFilename, "%s/%s%s", PathBackup, prefix, "KeySets.dat");
-  output.open(TEFilename, ios::out);
-  cout << Verbose(2) << "Saving " << prefix << " key sets of each subgraph ...";
-  for(int j=0;j<NumberOfMolecules;j++) {
-    //if (TEList[j] != 0) {
-      Walker = ListOfMolecules[j]->start;
-      while(Walker->next != ListOfMolecules[j]->end) {
-        Walker = Walker->next;        
-#ifdef ADDHYDROGEN
-        if ((Walker->GetTrueFather() != NULL) && (Walker->type->Z != 1)) // if there is a real father, prints its index
-#else
-        if ((Walker->GetTrueFather() != NULL)) // if there is a real father, prints its index
-#endif 
-          output <<  Walker->GetTrueFather()->nr << "\t";
-#ifdef ADDHYDROGEN
-        else  // otherwise a -1 to indicate an added saturation hydrogen
-          output << "-1\t";
-#endif 
-      }
-      //cout << endl << endl;
-      output << endl;
-    }
-  output.close();
-  cout << " done." << endl;
+  *out << " done." << endl;
   
   // printing final number
-  cout << "Final number of fragments: " << FragmentCounter << "." << endl;
+  *out << "Final number of fragments: " << FragmentCounter << "." << endl;
       
   return result;
 };
-
-/** Reduce the list of molecules to unique pieces.
- * molecule::IsEqualToWithinThreshold() is used by GetMappingToUniqueFragments() to provide a mapping for
- * ReduceFragmentToUniqueOnes(). 
- * \param *out output stream for debugging
- * \param cell_size 6 entries specifying the unit cell vectors (matrix is symmetric) for getting the map
- * \param celldistance needed for linked-cell technique when getting the map
- */
-void MoleculeListClass::ReduceToUniqueList(ofstream *out, double *cell_size, double celldistance)
-{
-  int *ReduceMapping = NULL;
-  
-  *out << Verbose(0) << "Begin of ReduceToUniqueList." << endl; 
-  // again, check whether there are equal fragments by ReduceToUniqueOnes
-  *out << Verbose(1) << "Get reduce mapping." << endl;
-  ReduceMapping = GetMappingToUniqueFragments(out, 0.05, cell_size, celldistance);
-  *out << Verbose(1) << "MapList: ";
-  for(int i=0;i<NumberOfMolecules;i++)
-    *out << ReduceMapping[i] << " ";
-  *out << endl << endl;
-  *out << Verbose(1) << "Apply reduce mapping." << endl;
-  ReduceFragmentToUniqueOnes(out, ReduceMapping);
-  Free((void **)&ReduceMapping, "MoleculeListClass::FragmentTopDown: *ReduceMapping");  // free map after reduce
-  *out << Verbose(1) << "Number of Fragments after Reducing is " << NumberOfMolecules << "." << endl;
-  *out << Verbose(0) << "End of ReduceToUniqueList." << endl; 
-};
-
-/** Fragments a molecule and resulting pieces recursively until the number of bonds
- * Here the idea is similar to the FragmentBottomUp() approach, only that we split up the molecule
- * bond per bond into left and right fragments and this recursively also with each yielded
- * fragment until there is no fragment with continuous number of bonds greater than \a BondDegree.
- * are below the given \a BondDegree.
- * \param *out output stream for debugging
- * \param BondDegree maximum number of continuous bonds in a fragment
- * \param bonddistance typical bond distance
- * \param *configuration configuration for writing config files for each fragment
- * \param CutCyclic cut cyclic bonds (saturate with hydrogen) or add 
- * \return pointer to MoleculeListClass with all the fragments or NULL if something went wrong.
- * \todo so far we volontarily mix up the above BondDegree definition and molecule::NoNonBonds
- * 
- * \bug  FragmentTopDown does not work right now due to NULL being given as cell_size to ReduceToUniqueOnes()
- */
-MoleculeListClass * MoleculeListClass::FragmentTopDown(ofstream *out, int BondDegree, double bonddistance, config *configuration, enum CutCyclicBond CutCyclic)
-{
-  int Num, No, Cyclic, NoBonds;
-  MoleculeListClass *ReturnList = NULL;
-  MoleculeListClass **FragmentsList = NULL;
-  molecule *CurrentMolecule = NULL;
-  bond *Binder = NULL;
- 
-  *out << Verbose(0) << "Begin of FragmentTopDown:" << this << "." << endl; 
-  Num = 0;
-  FragmentsList = (MoleculeListClass **) Malloc(sizeof(MoleculeListClass *)*NumberOfMolecules, "MoleculeListClass::FragmentTopDown: **FragmentsList");
-  // fragment each molecule into its own MoleculeListClass
-  for(int i=0;i<NumberOfMolecules;i++) {
-    CurrentMolecule = ListOfMolecules[i];
-    CurrentMolecule->CountAtoms(out);
-    Cyclic = CurrentMolecule->CountCyclicBonds(out);
-    NoBonds = 
-#ifdef ADDHYDROGEN
-CurrentMolecule->NoNonBonds
-#else 
-CurrentMolecule->BondCount
-#endif 
-                - ((CutCyclic == KeepBond) ? Cyclic : 0);
-    // check if NoNonBonds < BondDegree, then don't split any further: Here, correct for greatest continuous bond length!
-    *out << Verbose(0) << "Checking on Number of true Bonds " << NoBonds << " (i.e. no -H, if chosen no cyclic) greater than " << BondDegree << "." << endl;
-    if (NoBonds > BondDegree) {
-      //cerr << Verbose(1) << "TopDown Level of Molecule " << CurrentMolecule << ": " << (CurrentMolecule->NoNonBonds - BondDegree) << "." << endl; 
-      *out << Verbose(1) << "Breaking up molecule " << i << " in fragment list." << endl;
-      CurrentMolecule->CreateListOfBondsPerAtom(out);
-      // Get atomic fragments for the list
-      *out << Verbose(1) << "Getting Atomic fragments for molecule " << i << "." << endl;
-      MoleculeListClass *AtomicFragments = CurrentMolecule->GetAtomicFragments(out, NumberOfTopAtoms, configuration->GetIsAngstroem(), TEList[i]/(1. - NoBonds), CutCyclic);
-      
-      // build the atomic part of the list of molecules
-      *out << Verbose(1) << "Putting atomic fragment into list of molecules." << endl;
-      
-      // cutting cyclic bonds yields only a single fragment, not two as non-cyclic!
-      No = (CutCyclic == KeepBond) ? ((
-#ifdef ADDHYDROGEN
-CurrentMolecule->NoNonBonds - Cyclic)*2) : CurrentMolecule->NoNonBonds*2 - Cyclic; 
-#else 
-CurrentMolecule->BondCount - Cyclic)*2) : CurrentMolecule->BondCount*2 - Cyclic; 
-#endif 
-      
-      if (AtomicFragments != NULL) {
-        ReturnList = new MoleculeListClass(No+AtomicFragments->NumberOfMolecules, NumberOfTopAtoms);
-        for (int j=0;j<AtomicFragments->NumberOfMolecules;j++) { // shift all Atomic Fragments into this one here
-          ReturnList->ListOfMolecules[j+No] = AtomicFragments->ListOfMolecules[j];
-          AtomicFragments->ListOfMolecules[j] = NULL;
-          ReturnList->ListOfMolecules[j+No]->NoNonBonds = 0;
-          ReturnList->ListOfMolecules[j+No]->NoNonHydrogen = 1;
-          ReturnList->TEList[j+No] = AtomicFragments->TEList[j];
-        }
-        *out << Verbose(3) << "Freeing Atomic memory" << endl;
-        delete(AtomicFragments);
-        AtomicFragments = NULL;
-      } else {
-        *out << Verbose(2) << "AtomicFragments is NULL, filling list with whole molecule only." << endl; 
-        ReturnList = new MoleculeListClass(No, NumberOfTopAtoms);
-      }
-
-      // build the side pieces part of the list of molecules
-      *out << Verbose(1) << "Building side piece fragments and putting into list of molecules." << endl;
-      No = 0;
-      Binder = CurrentMolecule->first;
-      while(Binder->next != CurrentMolecule->last) {
-        Binder = Binder->next;
-#ifdef ADDHYDROGEN
-        if (Binder->HydrogenBond == 0)
-#endif        
-          if ((CutCyclic == SaturateBond) || (!Binder->Cyclic)) {
-            // split each bond into left and right side piece
-            if (Binder->Cyclic) {
-              molecule *dummy = NULL; // we lazily hand FragmentMoleculeByBond() a dummy as second fragment and ... 
-              *out << Verbose(1) << "Breaking up " << Binder->nr << "th and " << No << "th non-hydrogen, CYCLIC bond " << *Binder << " of molecule " << i << " [" << CurrentMolecule << "] into a single pieces." << endl; 
-              CurrentMolecule->FragmentMoleculeByBond(out, Binder, &(ReturnList->ListOfMolecules[No]), &(dummy), configuration->GetIsAngstroem(), CutCyclic);
-              delete(dummy);  // ... free the dummy which is due to the cyclic bond the exacy same fragment
-              *out << Verbose(1) << "Single fragment is " << ReturnList->ListOfMolecules[No] << "." << endl;
-      
-              // write down the necessary TE-summation in order to regain TE of whole molecule
-              *out << Verbose(2) << "Creating TEList for Fragment " << i << " of Bond " << No << "." << endl;
-#ifdef ADDHYDROGEN
-              ReturnList->TEList[No] = -TEList[i]/(1. -CurrentMolecule->NoNonBonds);
-#else              
-              ReturnList->TEList[No] = -TEList[i]/(1. -CurrentMolecule->BondCount);
-#endif
-            } else {
-              *out << Verbose(1) << "Breaking up " << Binder->nr << "th and " << No << "th non-hydrogen, non-cyclic bond " << *Binder << " of molecule " << i << " [" << CurrentMolecule << "] into left and right side pieces." << endl; 
-              CurrentMolecule->FragmentMoleculeByBond(out, Binder, &(ReturnList->ListOfMolecules[No]), &(ReturnList->ListOfMolecules[No+1]), configuration->GetIsAngstroem(), CutCyclic);
-              *out << Verbose(1) << "Left Fragment is " << ReturnList->ListOfMolecules[No] << ", right Fragment is " << ReturnList->ListOfMolecules[No+1] << "." << endl;
-      
-              // write down the necessary TE-summation in order to regain TE of whole molecule
-              *out << Verbose(2) << "Creating TEList for Fragment " << i << " of Bond " << No << "." << endl;
-              ReturnList->TEList[No] = -TEList[i]/(1. - NoBonds);
-              ReturnList->TEList[No+1] = -TEList[i]/(1. - NoBonds);
-            }
-            No += ((Binder->Cyclic) ? 1 : 2);
-          }
-      }
-
-      // Reduce this list
-      ReturnList->ReduceToUniqueList(out, NULL, bonddistance);
-
-      // recurse and receive List
-      *out << Verbose(1) << "Calling TopDown " << ReturnList<< " with filled list: ";
-      ReturnList->Output(out);
-      FragmentsList[i] = ReturnList->FragmentTopDown(out, BondDegree, bonddistance, configuration, CutCyclic);
-      *out << Verbose(1) << "Returning from TopDown " << ReturnList<< " with filled list: ";
-      ReturnList->Output(out);
-      
-      // remove list after we're done
-      *out << Verbose(2) << "Removing caller list." << endl;
-      delete(ReturnList);
-      ReturnList = NULL;
-      
-    } else {  // create a list with only a single molecule inside, transfer everything from "this" list to return list
-      *out << Verbose(1) << "Not breaking up molecule " << i << " in fragment list." << endl;
-      FragmentsList[i] = new MoleculeListClass(1, NumberOfTopAtoms);
-      FragmentsList[i]->ListOfMolecules[0] = ListOfMolecules[i];
-      ListOfMolecules[i] = NULL;
-      FragmentsList[i]->TEList[0] = TEList[i]; 
-    }
-    Num += FragmentsList[i]->NumberOfMolecules;
-  }
-  
-  // now, we have a list of MoleculeListClasses: combine all fragments list into one single list
-  *out << Verbose(2) << "Combining to a list of " << Num << " molecules and Memory cleanup of old list of lists." << endl; 
-  ReturnList = new MoleculeListClass(Num, NumberOfTopAtoms);
-  No = 0;
-  for(int i=0;i<NumberOfMolecules;i++) {
-    for(int j=0;j<FragmentsList[i]->NumberOfMolecules;j++) {
-      // transfer molecule
-      ReturnList->ListOfMolecules[No] = FragmentsList[i]->ListOfMolecules[j];
-      FragmentsList[i]->ListOfMolecules[j] = NULL;
-      // transfer TE factor
-      ReturnList->TEList[No] = FragmentsList[i]->TEList[j];
-      No++;
-    }
-    delete(FragmentsList[i]);
-    FragmentsList[i] = NULL;
-  }
-  Free((void **)&FragmentsList, "MoleculeListClass::FragmentTopDown: **FragmentsList");
-  
-  // Reduce the list to unique fragments
-  ReturnList->ReduceToUniqueList(out, NULL, bonddistance);
-  
-  // return pointer to list
-  *out << Verbose(0) << "Return with filled list: ";
-  ReturnList->Output(out);
-  
-  *out << Verbose(0) << "End of FragmentTopDown:" << this << "." << endl; 
-  return (ReturnList);
-}; 
 
 /******************************************* Class MoleculeLeafClass ************************************************/
